package cn.superdesk.uniorder.service.thirdpart.szhtxx.paperInvoice;

import cn.hutool.core.date.DateTime;
import cn.superdesk.uniorder.common.enums.thirdpart.szhtxx.paperInvoice.SzhtxxPaperInvoiceUsedEnum;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.thirdpart.szhtxx.paperInvoice.SzhtxxPaperInvoiceRedTaxInfo;
import cn.superdesk.uniorder.dto.param.thirdpart.szhtxx.paperInvoice.SzhtxxPaperInvoiceRedTaxInfoParam;
import cn.superdesk.uniorder.dto.param.thirdpart.szhtxx.paperInvoice.SzhtxxPaperInvoiceRedTaxInfoQueryCriteria;
import cn.superdesk.uniorder.dto.vo.thirdpart.szhtxx.paperInvoice.SzhtxxPaperInvoiceRedTaxInfoListItemVo;
import cn.superdesk.uniorder.service.base.BaseService;
import com.github.pagehelper.PageInfo;

import java.util.List;
import java.util.Map;


/**
 * @Description:
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2022-05-25 18:50:54
 * @UpdateUser: linjinyu
 * @UpdateDate: 2022-05-25 18:50:54
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface SzhtxxPaperInvoiceRedTaxInfoService extends BaseService<SzhtxxPaperInvoiceRedTaxInfo> {


    /****************************************** extends BaseService 部分 start ******************************************/

    int insertSelective(SzhtxxPaperInvoiceRedTaxInfo entity);

    int updateByPrimaryKeySelective(SzhtxxPaperInvoiceRedTaxInfo entity);

    int saveOrUpdateByRedTaxInfoSn(SzhtxxPaperInvoiceRedTaxInfo entity, DateTime now, LoginSysUser loginSysUser);

    int saveOrUpdateByRedTaxInfoLshAndBatchId(SzhtxxPaperInvoiceRedTaxInfo entity, DateTime now, LoginSysUser loginSysUser);

    int opUpdateLogicalTemp2Normal(String batchId, String redTaxInfoSn, LoginSysUser loginSysUser);

    @Deprecated
    void deleteObj(Long id);

    @Deprecated
    SzhtxxPaperInvoiceRedTaxInfo findById(Long id);

    SzhtxxPaperInvoiceRedTaxInfo findByRedTaxInfoSn(String redTaxInfoSn);

    SzhtxxPaperInvoiceRedTaxInfo findByRedTaxInfoLshAndBatchId(String redTaxInfoLsh, String batchId);

    @Deprecated
    PageInfo<SzhtxxPaperInvoiceRedTaxInfo> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize);

    @Deprecated
    List<SzhtxxPaperInvoiceRedTaxInfo> findAll(Map<String, Object> queryMap);

    /****************************************** extends BaseService 部分   end ******************************************/


    int addSzhtxxPaperInvoiceRedTaxInfo(SzhtxxPaperInvoiceRedTaxInfo entity);

    int saveOrUpdateSzhtxxPaperInvoiceRedTaxInfoParam(SzhtxxPaperInvoiceRedTaxInfoParam param, LoginSysUser loginSysUser);

    int updateSzhtxxPaperInvoiceRedTaxInfo(SzhtxxPaperInvoiceRedTaxInfo entity);

    int updateFieldUsedByRedTaxInfoSn(String redTaxInfoSn, SzhtxxPaperInvoiceUsedEnum szhtxxPaperInvoiceUsedEnum, LoginSysUser loginSysUser);

    int deleteSzhtxxPaperInvoiceRedTaxInfo(Long id);

    SzhtxxPaperInvoiceRedTaxInfo findSzhtxxPaperInvoiceRedTaxInfoById(Long id);

    R<List<SzhtxxPaperInvoiceRedTaxInfo>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize);

    R<List<SzhtxxPaperInvoiceRedTaxInfoListItemVo>> pageQueryGenericParam(SzhtxxPaperInvoiceRedTaxInfoQueryCriteria criteria);


}